if autoupdate = true then
  PreviewListView.Items.BeginUpdate;
try
  for i := 0 to filelist.Count - 1 do
  begin
    date := GetFileDate(filelist[i]);
    if yearscheckbox.checked then
      date := incyear(recodeyear(date, YearsStartSpinEdit.Value),
        i * yearsincspinedit.Value);
    if monthscheckbox.checked then
      date := incMonth(recodeMonth(date, MonthsStartSpinEdit.Value),
        i * Monthsincspinedit.Value);
    if dayscheckbox.checked then
      date := incDay(recodeDay(date, DaysStartSpinEdit.Value),
        i * Daysincspinedit.Value);
    if hourscheckbox.checked then
      date := incHour(recodeHour(date, HoursStartSpinEdit.Value),
        i * Hoursincspinedit.Value);
    if minutescheckbox.checked then
      date := incMinute(recodeMinute(date, MinutesStartSpinEdit.Value),
        i * Minutesincspinedit.Value);
    if secondscheckbox.checked then
      date := incSecond(recodeSecond(date, SecondsStartSpinEdit.Value),
        i * Secondsincspinedit.Value);
    if millisecondscheckbox.checked then
      date := incMillisecond(recodeMillisecond(date, MillisecondsStartSpinEdit.Value),
        i * Millisecondsincspinedit.Value);
    if autoupdate = true then
    begin
      PreviewListView.Items.Item[i].SubItems[1] :=
        formatdatetime(DTFormat, date);
      PDateTime(PreviewListView.Items[i].Data)^ := date;
    end;
  end;
finally
  if autoupdate = true then
    PreviewListView.Items.EndUpdate;
end;
